ChatGPT解决这个技术问题 Extra ChatGPT

How to check the exit status using an 'if' statement

What would be the best way to check the exit status in an if statement in order to echo a specific output?

I'm thinking of it being:

if [ $? -eq 1 ] 
then
    echo "blah blah blah"
fi

The issue I am also having is that the exit statement is before the if statement simply because it has to have that exit code. Also, I know I'm doing something wrong since the exit would obviously exit the program.

Plaese post your complete script (or at least a broader scope). Else this seems fine.
If you need to use the exit code from some particular program invocation in two different places, then you need to preserve it - something along the lines of some_program; rc=$?; if [ ${rc} -eq 1 ] .... fi ; exit ${rc}

P
Peter Mortensen

Every command that runs has an exit status.

That check is looking at the exit status of the command that finished most recently before that line runs.

If you want your script to exit when that test returns true (the previous command failed) then you put exit 1 (or whatever) inside that if block after the echo.

That being said, if you are running the command and are wanting to test its output, using the following is often more straightforward.

if some_command; then
    echo command returned true
else
    echo command returned some error
fi

Or to turn that around use ! for negation

if ! some_command; then
    echo command returned some error
else
    echo command returned true
fi

Note though that neither of those cares what the error code is. If you know you only care about a specific error code then you need to check $? manually.


@deadcell4 When one needs to terminate a shell script on a program failure, the following idiom is useful a_command || return 1
@gboffi return only works in a function and a sourced script. You need exit for the other case (which does too much in a function and a sourced script). But yes, that's certainly a reasonable pattern if you don't need any specific cleanup or extra output.
I have to say that dash, the default non-interactive shell in many modern linux distributions, don't care of the distinction between return and exit inside of executed shell scripts. dash exits the script even if I use return in it.
What is the logic behind the last two checks? It seems counter-intuitive that the condition if <command> passes if the exit code is 0. In any other language it would be the other way around
IMPORTANT NOTE: This won't work for pipes. if ! some_command | some_other_command will ignore the status of some_command. The two most command workarounds are to set -o pipefail (may change functionality in other parts of your program) or to move the if statement to if [[ ${PIPESTATUS[0]} -ne 0 ]] as a separate follow-up command (ugly, but functional). If you're using set -e then you'll also want to add || true to the end of the pipe when using the second solution since removing the pipe from the control flow offered by if would otherwise cause it to immediately exit.
P
Peter Mortensen

Note that exit codes != 0 are used to report errors. So, it's better to do:

retVal=$?
if [ $retVal -ne 0 ]; then
    echo "Error"
fi
exit $retVal

instead of

# will fail for error codes == 1
retVal=$?
if [ $retVal -eq 1 ]; then
    echo "Error"
fi
exit $retVal

You must test on retVal, because $? after the assignment of retVal is not the return value from your command.
Not really: mywiki.wooledge.org/BashFAQ/002 - however, I agree that edit improves the readability.
Just found this post that explains it stackoverflow.com/questions/20157938/…
@jww - well, that's not quite a good idea to go against convention (gnu.org/software/bash/manual/html_node/Exit-Status.html). But, well, there is nothing to prevent that. If dnf developers have chosen this way, it's their choice. But still, their choice doesn't make the specification to be broken :)
# will fail for error codes > 1 but $retVal -eq 1 checks for error code equal 1?
P
Peter Mortensen

An alternative to an explicit if statement

Minimally:

test $? -eq 0 || echo "something bad happened"

Complete:

EXITCODE=$?
test $EXITCODE -eq 0 && echo "something good happened" || echo "something bad happened";
exit $EXITCODE

c
chepner

$? is a parameter like any other. You can save its value to use before ultimately calling exit.

exit_status=$?
if [ $exit_status -eq 1 ]; then
    echo "blah blah blah"
fi
exit $exit_status

S
Sled

For the record, if the script is run with set -e (or #!/bin/bash -e) and you therefore cannot check $? directly (since the script would terminate on any return code other than zero), but want to handle a specific code, @gboffis comment is great:

/some/command || error_code=$?
if [ "${error_code}" -eq 2 ]; then
   ...

Doesn't this break if /some/command is in the PATH? error_code is not set.
I don't see how that would interfere. You can try /bin/mkdir on an existing directory, that should return 1. Are you certain the command you tried did return an exit code other than 0? /usr/bin/file on an non-existant file for example prints an error but still returns 0 🤷
@Justin, I agree. I think it's better to use || is_fail=true; if [ "$is_fail" = true ]; then . . .
c
codeforester

Just to add to the helpful and detailed answer:

If you have to check the exit code explicitly, it is better to use the arithmetic operator, (( ... )), this way:

run_some_command
(($? != 0)) && { printf '%s\n' "Command exited with non-zero"; exit 1; }

Or, use a case statement:

run_some_command; ec=$?  # grab the exit code into a variable so that it can
                         # be reused later, without the fear of being overwritten
case $ec in
    0) ;;
    1) printf '%s\n' "Command exited with non-zero"; exit 1;;
    *) do_something_else;;
esac

Related answer about error handling in Bash:

Raise error in a Bash script


Could you elaborate on why it is better to use the arithmetic operator?
This answer is actually incorrect. You can't use $? in a boolean check like that, regardless of whether you use (( $? != 0 )) or [[ $? -ne 0 ]] because it doesn't get parsed like normal vars do (related description).
Re why arithmetic is better: It's not, just personal preference. I like it more b/c it's shorter, i.e. (( $retVal )) && echo 'ERROR' instead of (( $retVal != 0 )) or [[ $retVal -ne 0 ]] but that doesn't necessarily mean it's better. In fact, the shortcut I like to use would be confusing to anyone who doesn't know Bash all that well.
P
Peter Mortensen

If you are writing a function – which is always preferred – you can propagate the error like this:

function()
{
    if <command>; then
        echo worked
    else
        return
    fi
}

Now, the caller can do things like function && next as expected! This is useful if you have a lot of things to do in the if block, etc. (otherwise there are one-liners for this). It can easily be tested using the false command.


P
Peter Mortensen

Using Z shell (zsh) you can simply use:

if [[ $(false)? -eq 1 ]]; then echo "yes" ;fi

When using Bash and set -e is on, you can use:

false || exit_code=$?
if [[ ${exit_code} -ne 0 ]]; then echo ${exit_code}; fi

J
JonC

This might only be useful in a limited set of use-cases, I use this specifically when I need to capture the output from a command and write it to a log file if the exit code reports that something went wrong.

RESULT=$(my_command_that_might_fail)
if (exit $?) 
then
    echo "everything went fine."    
else
    echo "ERROR: $RESULT" >> my_logfile.txt
fi